Index: /TOOLS/MOSAIX/nemo.py
===================================================================
--- /TOOLS/MOSAIX/nemo.py	(revision 6665)
+++ /TOOLS/MOSAIX/nemo.py	(revision 6666)
@@ -18,72 +18,129 @@
 ##
 ## ===========================================================================
+'''Utilities to plot NEMO ORCA fields,
+
+Handles periodicity and other stuff
+
+- Lots of tests for xarray object
+- Not much tested for numpy objects
+
+Author: olivier.marti@lsce.ipsl.fr
+
+## SVN information
+Author   = "$Author$"
+Date     = "$Date$"
+Revision = "$Revision$"
+Id       = "$Id$"
+HeadURL  = "$HeadURL$"
 '''
-Utilities to plot NEMO ORCA fields
-Periodicity and other stuff
-
-olivier.marti@lsce.ipsl.fr
-'''
-
-## SVN information
-__Author__   = "$Author$"
-__Date__     = "$Date$"
-__Revision__ = "$Revision$"
-__Id__       = "$Id$"
-__HeadURL    = "$HeadURL$"
 
 import numpy as np
-try    : import xarray as xr
-except ImportError : pass
-
-try    : import f90nml
-except : pass
-
-try : from sklearn.impute import SimpleImputer
-except : pass
-
-try    : import numba
-except : pass
-
-rpi = np.pi ; rad = np.deg2rad (1.0) ; dar = np.rad2deg (1.0)
-
-nperio_valid_range = [0, 1, 4, 4.2, 5, 6, 6.2]
-
-rday   = 24.*60.*60.     # Day length [s]
-rsiyea = 365.25 * rday * 2. * rpi / 6.283076 # Sideral year length [s]
-rsiday = rday / (1. + rday / rsiyea)
-raamo  =  12.        # Number of months in one year
-rjjhh  =  24.        # Number of hours in one day
-rhhmm  =  60.        # Number of minutes in one hour
-rmmss  =  60.        # Number of seconds in one minute
-omega  = 2. * rpi / rsiday # Earth rotation parameter [s-1]
-ra     = 6371229.    # Earth radius [m]
-grav   = 9.80665     # Gravity [m/s2]
-repsi  = np.finfo (1.0).eps
-
-xList = [ 'x', 'X', 'lon'   , 'longitude' ]
-yList = [ 'y', 'Y', 'lat'   , 'latitude'  ]
-zList = [ 'z', 'Z', 'depth' , ]
-tList = [ 't', 'T', 'time'  , ]
+import xarray as xr
+
+# Tries to import some moldules that are available in all Python installations
+#  and used in only a few specific functions
+try :
+    from sklearn.impute import SimpleImputer
+except ImportError as err :
+    print ( f'===> Warning : Module nemo : Import error of sklearn.impute.SimpleImputer : {err}' )
+    SimpleImputer = None
+
+try :
+    import f90nml
+except ImportError as err :
+    print ( f'===> Warning : Module nemo : Import error of f90nml : {err}' )
+    f90nml = None
+
+# SVN information
+__SVN__ = ({
+    'Author'   : '$Author$',
+    'Date'     : '$Date$',
+    'Revision' : '$Revision$',
+    'Id'       : '$Id$',
+    'HeadURL'  : '$HeadURL$',
+    'SVN_Date' : '$SVN_Date: $',
+    })
+##
+    
+RPI   = np.pi
+RAD   = np.deg2rad (1.0)
+DAR   = np.rad2deg (1.0)
+REPSI = np.finfo (1.0).eps
+
+NPERIO_VALID_RANGE = [0, 1, 4, 4.2, 5, 6, 6.2]
+
+RAAMO    =      12          # Number of months in one year
+RJJHH    =      24          # Number of hours in one day
+RHHMM    =      60          # Number of minutes in one hour
+RMMSS    =      60          # Number of seconds in one minute
+RA       = 6371229.0        # Earth radius                                  [m]
+GRAV     =       9.80665    # Gravity                                       [m/s2]
+RT0      =     273.15       # Freezing point of fresh water                 [Kelvin]
+RAU0     =    1026.0        # Volumic mass of sea water                     [kg/m3]
+SICE     =       6.0        # Salinity of ice (for pisces)                  [psu]
+SOCE     =      34.7        # Salinity of sea (for pisces and isf)          [psu]
+RLEVAP   =       2.5e+6     # Latent heat of evaporation (water)            [J/K]
+VKARMN   =       0.4        # Von Karman constant
+STEFAN   =       5.67e-8    # Stefan-Boltzmann constant                     [W/m2/K4]
+RHOS     =     330.         # Volumic mass of snow                          [kg/m3]
+RHOI     =     917.         # Volumic mass of sea ice                       [kg/m3]
+RHOW     =    1000.         # Volumic mass of freshwater in melt ponds      [kg/m3]
+RCND_I   =       2.034396   # Thermal conductivity of fresh ice             [W/m/K]
+RCPI     =    2067.0        # Specific heat of fresh ice                    [J/kg/K]
+RLSUB    =       2.834e+6   # Pure ice latent heat of sublimation           [J/kg]
+RLFUS    =       0.334e+6   # Latent heat of fusion of fresh ice            [J/kg]
+RTMLT    =       0.054      # Decrease of seawater meltpoint with salinity
+
+RDAY     = RJJHH * RHHMM * RMMSS                # Day length               [s]
+RSIYEA   = 365.25 * RDAY * 2. * RPI / 6.283076  # Sideral year length      [s]
+RSIDAY   = RDAY / (1. + RDAY / RSIYEA)          # Sideral day length       [s]
+OMEGA    = 2. * RPI / RSIDAY                    # Earth rotation parameter [s-1]
+
+## Default names of dimensions
+UDIMS = {'x':'x', 'y':'y', 'z':'olevel', 't':'time_counter'}
+
+## All possibles name of dimensions in Nemo files
+XNAME = [ 'x', 'X', 'X1', 'xx', 'XX',
+              'x_grid_T', 'x_grid_U', 'x_grid_V', 'x_grid_F', 'x_grid_W',
+              'lon', 'nav_lon', 'longitude', 'X1', 'x_c', 'x_f', ]
+YNAME = [ 'y', 'Y', 'Y1', 'yy', 'YY',
+              'y_grid_T', 'y_grid_U', 'y_grid_V', 'y_grid_F', 'y_grid_W',
+              'lat', 'nav_lat', 'latitude' , 'Y1', 'y_c', 'y_f', ]
+ZNAME = [ 'z', 'Z', 'Z1', 'zz', 'ZZ', 'depth', 'tdepth', 'udepth',
+              'vdepth', 'wdepth', 'fdepth', 'deptht', 'depthu',
+              'depthv', 'depthw', 'depthf', 'olevel', 'z_c', 'z_f', ]
+TNAME = [ 't', 'T', 'tt', 'TT', 'time', 'time_counter', 'time_centered', ]
+
+## All possibles name of units of dimensions in Nemo files
+XUNIT = [ 'degrees_east', ]
+YUNIT = [ 'degrees_north', ]
+ZUNIT = [ 'm', 'meter', ]
+TUNIT = [ 'second', 'minute', 'hour', 'day', 'month', 'year', ]
+
+## All possibles size of dimensions in Orca files
+XLENGTH = [ 180, 182, 360, 362, 1440 ]
+YLENGTH = [ 148, 149, 331, 332 ]
+ZLENGTH = [ 31, 75]
 
 ## ===========================================================================
-def __mmath__ (tab, default=None) :
+def __mmath__ (ptab, default=None) :
+    '''Determines the type of tab : xarray, numpy or numpy.ma object ?
+
+    Returns type
+    '''
     mmath = default
-    try    :
-        if type (tab) == xr.core.dataarray.DataArray : mmath = xr
-    except :
-        pass
-
-    try    :
-        if type (tab) == np.ndarray : mmath = np
-    except :
-        pass
-            
+    if isinstance (ptab, xr.core.dataarray.DataArray) :
+        mmath = xr
+    if isinstance (ptab, np.ndarray) :
+        mmath = np
+    if isinstance (ptab, np.ma.MaskType) :
+        mmath = np.ma
+
     return mmath
 
-
-def __guessNperio__ (jpj, jpi, nperio=None, out='nperio') :
-    '''
-    Tries to guess the value of nperio (periodicity parameter. See NEMO documentation for details)
-    
+def __guess_nperio__ (jpj, jpi, nperio=None, out='nperio') :
+    '''Tries to guess the value of nperio (periodicity parameter.
+
+    See NEMO documentation for details)
     Inputs
     jpj    : number of latitudes
@@ -91,13 +148,12 @@
     nperio : periodicity parameter
     '''
-    if nperio == None :
-        nperio = __guessConfig__ (jpj, jpi, nperio=None, out='nperio')
-    
+    if nperio is None :
+        nperio = __guess_config__ (jpj, jpi, nperio=None, out=out)
     return nperio
 
-def __guessConfig__ (jpj, jpi, nperio=None, config=None, out='nperio') :
-    '''
-    Tries to guess the value of nperio (periodicity parameter. See NEMO documentation for details)
-    
+def __guess_config__ (jpj, jpi, nperio=None, config=None, out='nperio') :
+    '''Tries to guess the value of nperio (periodicity parameter).
+
+    See NEMO documentation for details)
     Inputs
     jpj    : number of latitudes
@@ -105,54 +161,51 @@
     nperio : periodicity parameter
     '''
-    if nperio == None :
+    print ( jpi, jpj)
+    if nperio is None :
         ## Values for NEMO version < 4.2
-        if jpj ==  149 and jpi ==  182 :
-            config = 'ORCA2.3'
-            nperio = 4   # ORCA2. We choose legacy orca2.
-            Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'T'
-        if jpj ==  332 and jpi ==  362 : # eORCA1.
-            config = 'eORCA1.2'
-            nperio = 6  
-            Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'F'
+        if ( (jpj == 149 and jpi == 182) or (jpj is None and jpi == 182) or
+             (jpj == 149 or jpi is None) ) :
+            # ORCA2. We choose legacy orca2.
+            config, nperio, iperio, jperio, nfold, nftype = 'ORCA2.3' , 4, 1, 0, 1, 'T'
+        if ((jpj == 332 and jpi == 362) or (jpj is None and jpi == 362) or
+            (jpj ==  332 and jpi is None) ) : # eORCA1.
+            config, nperio, iperio, jperio, nfold, nftype = 'eORCA1.2', 6, 1, 0, 1, 'F'
         if jpi == 1442 :  # ORCA025.
-            config = 'ORCA025'
-            nperio = 6 
-            Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'F'
+            config, nperio, iperio, jperio, nfold, nftype = 'ORCA025' , 6, 1, 0, 1, 'F'
         if jpj ==  294 : # ORCA1
-            config = 'ORCA1'
-            nperio = 6
-            Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'F'
-            
+            config, nperio, iperio, jperio, nfold, nftype = 'ORCA1'   , 6, 1, 0, 1, 'F'
+
         ## Values for NEMO version >= 4.2. No more halo points
-        if jpj == 148 and jpi ==  180 :
-            config = 'ORCA2.4'
-            nperio = 4.2 # ORCA2. We choose legacy orca2.
-            Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'F'
-        if jpj == 331  and jpi ==  360 : # eORCA1.
-            config = 'eORCA1.4'
-            nperio = 6.2
-            Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'F'
+        if  (jpj == 148 and jpi == 180) or (jpj is None and jpi == 180) or \
+            (jpj == 148 and jpi is None) :  # ORCA2. We choose legacy orca2.
+            config, nperio, iperio, jperio, nfold, nftype = 'ORCA2.4' , 4.2, 1, 0, 1, 'F'
+        if  (jpj == 331 and jpi == 360) or (jpj is None and jpi == 360) or \
+            (jpj == 331 and jpi is None) : # eORCA1.
+            config, nperio, iperio, jperio, nfold, nftype = 'eORCA1.4', 6.2, 1, 0, 1, 'F'
         if jpi == 1440 : # ORCA025.
-            config = 'ORCA025'
-            nperio = 6.2
-            Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'F'
-            
-        if nperio == None :
-            raise Exception  ('in nemo module : nperio not found, and cannot by guessed')
+            config, nperio, iperio, jperio, nfold, nftype = 'ORCA025' , 6.2, 1, 0, 1, 'F'
+
+        if nperio is None :
+            raise ValueError ('in nemo module : nperio not found, and cannot by guessed')
+
+        if nperio in NPERIO_VALID_RANGE :
+            print ( f'nperio set as {nperio} (deduced from {jpj=} and {jpi=})' )
         else :
-            if nperio in nperio_valid_range :
-                print ('nperio set as {:} (deduced from jpj={:d} jpi={:d})'.format (nperio, jpj, jpi))
-            else : 
-                raise ValueError ('nperio set as {:} (deduced from jpi={:d}) : nemo.py is not ready for this value'.format (nperio, jpi))
-
-    if out == 'nperio' : return nperio
-    if out == 'config' : return config
-    if out == 'perio'  : return Iperio, Jperio, NFold, NFtype
-    if out in ['full', 'all'] : return {'nperio':nperio, 'Iperio':Iperio, 'Jperio':Jperio, 'NFold':NFold, 'NFtype':NFtype}
-        
-def __guessPoint__ (ptab) :
-    '''
-    Tries to guess the grid point (periodicity parameter. See NEMO documentation for details)
-    
+            raise ValueError ( f'nperio set as {nperio} (deduced from {jpi=} and {jpj=}) : \n'+
+                                'nemo.py is not ready for this value' )
+
+    if out == 'nperio' :
+        return nperio
+    if out == 'config' :
+        return config
+    if out == 'perio'  :
+        return iperio, jperio, nfold, nftype
+    if out in ['full', 'all'] :
+        return {'nperio':nperio, 'iperio':iperio, 'jperio':jperio, 'nfold':nfold, 'nftype':nftype}
+
+def __guess_point__ (ptab) :
+    '''Tries to guess the grid point (periodicity parameter.
+
+    See NEMO documentation for details)
     For array conforments with xgcm requirements
 
